ResultList (Search Engine) (Deprecated)
ResultList (Search Engine) (Deprecated)
|
|
Headless v1 has been deprecated. We recommend using the latest version of the Coveo Headless library. |
Example implementation
result-list.fn.tsx
import {ResultList as HeadlessResultList} from '@coveo/headless';
import {useEffect, useState, FunctionComponent} from 'react';
import {Quickview} from '../quickview/quickview.fn';
import {ResultLink} from './result-link';
interface ResultListProps {
controller: HeadlessResultList;
}
export const ResultList: FunctionComponent<ResultListProps> = (props) => {
const {controller} = props;
const [state, setState] = useState(controller.state);
useEffect(() => controller.subscribe(() => setState(controller.state)), []);
if (!state.results.length) {
return <div>No results</div>;
}
return (
<div>
<ul style={{textAlign: 'left'}}>
{state.results.map((result) => (
<li key={result.uniqueId}>
<article>
<h3>
{/* Make sure to log analytics when the result link is clicked. */}
<ResultLink result={result}>{result.title}</ResultLink>
</h3>
<p>{result.excerpt}</p>
<div>
<Quickview result={result} />
</div>
</article>
</li>
))}
</ul>
</div>
);
};
// usage
/**
* ```tsx
* const controller = buildResultList(engine);
*
* <ResultList controller={controller} />;
* ```
*/
The ResultList headless controller offers a high-level interface for designing a common result list UI controller.
Methods
fetchMoreResults
Using the same parameters as the last successful query, fetch another batch of results, if available. Particularly useful for infinite scrolling, for example.
This method is not compatible with the Pager controller.
subscribe
Adds a callback that’s invoked on state change.
Parameters
-
listener:
() => voidA callback that’s invoked on state change.
Returns Unsubscribe: A function to remove the listener.
Attributes
state
The state of the ResultList controller.
Properties
-
moreResultsAvailable:
booleanWhether more results are available, using the same parameters as the last successful query.
This property is not compatible with the
Pagercontroller. -
results:
Result[]The results of the last executed search.
-
searchResponseId:
stringThe unique identifier of the response where the results were fetched, this value does not change when loading more results.
-
searchUid:
stringThe unique identifier of the last executed search.
-
firstSearchExecuted:
booleanDetermines if a first search has been executed.
-
hasError:
booleantrueif there’s an error for the last executed query andfalseotherwise. -
hasResults:
booleanDetermines if there are results available for the last executed query.
-
isLoading:
booleanDetermines if a search is in progress.
Initialize
buildResultList
Creates a ResultList controller instance.
Parameters
-
engine:
SearchEngineThe headless engine.
-
props:
ResultListPropsThe configurable
ResultListproperties.
Returns ResultList
ResultListProps
The configurable ResultList properties.
Properties
-
fetchMoreResultsActionCreator?:
() => AsyncThunkAction<unknown, void, any>The action creator to build the
fetchMoreResultsaction. -
options?:
ResultListOptionsThe options for the
ResultListcontroller.
ResultListOptions
The options for the ResultList controller.
Properties
-
fieldsToInclude?:
string[]A list of indexed fields to include in the objects returned by the result list. These results are included in addition to the default fields. If this is left empty only the default fields are included.
Related types
HighlightKeyword
Properties
-
length:
numberThe length of the offset.
-
offset:
numberThe 0 based offset inside the string where the highlight should start.
Raw
Properties
-
[key: string]:
unknownCustom keys that depend on the documents in the index.
Result
Properties
-
absentTerms:
string[]The basic query expression terms which this query result item does not match. Note: This property is populated by terms from the query pipeline-processed q value (not from the original q value).
-
clickUri:
stringThe hyperlinkable item URI. Notes: Use the clickUri value when you want to create hyperlinks to the item, rather than the uri or printableUri value.
-
excerpt:
stringThe contextual excerpt generated for the item (see the excerptLength query parameter).
-
excerptHighlights:
HighlightKeyword[]The length and offset of each word to highlight in the item excerpt string.
-
firstSentences:
stringThe first sentences retrieved from the item (see the retrieveFirstSentences query parameter).
-
firstSentencesHighlights:
HighlightKeyword[]The length and offset of each word to highlight in the item firstSentences string.
-
flags:
stringThe flags that are set on the item by the index. Distinct values are separated by semicolons.
-
hasHtmlVersion:
booleanWhether the index contains an HTML version of this item.
-
isRecommendation:
booleanWhether the item score was boosted as a Coveo ML recommendation.
-
isTopResult:
booleanWhether the item score was boosted by a featured result rule in the query pipeline.
-
percentScore:
numberThe item ranking score expressed as a percentage (see the sortCriteria and rankingFunctions query parameters).
-
printableUri:
stringThe human readable item URI. Note: Avoid using the printableUri value to create hyperlinks to the item. Use the clickUri value instead.
-
printableUriHighlights:
HighlightKeyword[]The length and offset of each word to highlight in the item printableUri string.
-
rankingInfo:
string | nullThe raw debug information generated by the index to detail how the item was ranked. This property is null unless the debug query parameter is set to true.
-
raw:
RawThe values of the fields which were retrieved for this item (see the fieldsToInclude and fieldsToExclude query parameters).
-
score:
numberThe total ranking score computed for the item (see the sortCriteria and rankingFunctions query parameters).
-
summary:
nullThe item summary (see the summaryLength query parameter).
-
summaryHighlights:
HighlightKeyword[]The length and offset of each word to highlight in the item summary string.
-
title:
stringContains the title of the item.
-
titleHighlights:
HighlightKeyword[]The length and offset of each word to highlight in the item title string.
-
uniqueId:
stringThe unique item identifier. You should consider the uniqueId value as an opaque string.
-
uri:
stringThe item URI. Notes: Avoid using the uri value to create hyperlinks to the item. Use the clickUri value instead.
-
rankingModifier?:
stringIf applicable, represents the type of ranking modification that was applied to this result.
Unsubscribe
Call signatures
-
(): void